#include "BGV2ActiveXTrial.h"
#include <userint.h>

static void CVIFUNC _BeauGaugeCtrlTrialEventsRegOnValueChanged_EventVTableFunc (void *thisPtr,
                                                                                BSTR sName,
                                                                                double fValue);

static void CVIFUNC _BeauGaugeCtrlTrialEventsRegOnRightClicked_EventVTableFunc (void *thisPtr,
                                                                                long nX,
                                                                                long nY);

#define __ActiveXCtrlErrorHandler() \
if ((ctrlId) > 0) \
	{ \
	if (controlID) \
		*controlID = (ctrlId); \
	if (UILError) \
		*UILError = 0; \
	__result = S_OK; \
	} \
else if ((ctrlId) == UIEActiveXError) \
	{ \
	if (controlID) \
		*controlID = 0; \
	if (UILError) \
		*UILError = 0; \
	} \
else \
	{ \
	if (controlID) \
		*controlID = 0; \
	if (UILError) \
		*UILError = (ctrlId); \
	__result = E_CVIAUTO_CVI_UI_ERROR; \
	}

static CA_PARAMDATA __BeauGaugeCtrlTrialEvents_RegOnValueChanged_CA_PARAMDATA[] =
	{
		{"sName", VT_BSTR},
        {"fValue", VT_R8}
	};

static CA_PARAMDATA __BeauGaugeCtrlTrialEvents_RegOnRightClicked_CA_PARAMDATA[] =
	{
		{"nX", VT_I4},
        {"nY", VT_I4}
	};

static CA_METHODDATA __BeauGaugeCtrlTrialEvents_CA_METHODDATA[] =
	{
		{"ValueChanged", __BeauGaugeCtrlTrialEvents_RegOnValueChanged_CA_PARAMDATA, 1, 0, CC_STDCALL, 2, DISPATCH_METHOD, VT_EMPTY},
        {"RightClicked", __BeauGaugeCtrlTrialEvents_RegOnRightClicked_CA_PARAMDATA, 2, 1, CC_STDCALL, 2, DISPATCH_METHOD, VT_EMPTY}
	};

static CA_INTERFACEDATA __BeauGaugeCtrlTrialEvents_CA_INTERFACEDATA =
	{
		__BeauGaugeCtrlTrialEvents_CA_METHODDATA,
        (unsigned int)(sizeof (__BeauGaugeCtrlTrialEvents_CA_METHODDATA) / sizeof (*__BeauGaugeCtrlTrialEvents_CA_METHODDATA))
	};

static void * __BeauGaugeCtrlTrialEvents_EventVTable[] =
	{
		_BeauGaugeCtrlTrialEventsRegOnValueChanged_EventVTableFunc,
        _BeauGaugeCtrlTrialEventsRegOnRightClicked_EventVTableFunc
	};

static CAEventClassDefn __BeauGaugeCtrlTrialEvents_CAEventClassDefn =
	{
		(int)sizeof(CAEventClassDefn),
        &BGV2ActiveXTrialLib_IID__BeauGaugeCtrlTrialEvents,
        __BeauGaugeCtrlTrialEvents_EventVTable,
        &__BeauGaugeCtrlTrialEvents_CA_INTERFACEDATA,
        0
	};

const IID BGV2ActiveXTrialLib_IID__BeauGaugeCtrlTrial =
	{
		0xD9381619, 0xE4E3, 0x4163, 0x94, 0x31, 0xFA, 0x71, 0x15, 0x7A, 0xF, 0x10
	};

const IID BGV2ActiveXTrialLib_IID__BeauGaugeCtrlTrialEvents =
	{
		0x1F6BC7D1, 0x80A6, 0x44E8, 0xB5, 0x96, 0x3B, 0xA4, 0x4D, 0x52, 0xCD, 0x10
	};

HRESULT CVIFUNC BGV2ActiveXTrialLib_New_BeauGaugeCtrlTrial (int panel,
                                                            const char *label,
                                                            int top, int left,
                                                            int *controlID,
                                                            int *UILError)
{
	HRESULT __result = S_OK;
	int ctrlId;
	GUID clsid = {0xE6E4F07D, 0x732F, 0x4E80, 0x94, 0x97, 0xBF, 0xD7, 0x40,
	              0x3D, 0xEE, 0x10};
	const char * licStr = NULL;

	ctrlId = NewActiveXCtrl (panel, label, top, left, &clsid,
	                         &BGV2ActiveXTrialLib_IID__BeauGaugeCtrlTrial,
	                         licStr, &__result);

	__ActiveXCtrlErrorHandler();

	return __result;
}

HRESULT CVIFUNC BGV2ActiveXTrialLib__BeauGaugeCtrlTrialAboutBox (CAObjHandle objectHandle,
                                                                 ERRORINFO *errorInfo)
{
	HRESULT __result = S_OK;

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &BGV2ActiveXTrialLib_IID__BeauGaugeCtrlTrial,
	                              0xFFFFFDD8, CAVT_EMPTY, NULL, 0, NULL);

	return __result;
}

HRESULT CVIFUNC BGV2ActiveXTrialLib__BeauGaugeCtrlTrialSetBackgroundColor (CAObjHandle objectHandle,
                                                                           ERRORINFO *errorInfo,
                                                                           long nR,
                                                                           long nG,
                                                                           long nB)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG, CAVT_LONG, CAVT_LONG};

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &BGV2ActiveXTrialLib_IID__BeauGaugeCtrlTrial,
	                              0x2, CAVT_EMPTY, NULL, 3, __paramTypes, nR,
	                              nG, nB);

	return __result;
}

HRESULT CVIFUNC BGV2ActiveXTrialLib__BeauGaugeCtrlTrialGetCtrlPtr (CAObjHandle objectHandle,
                                                                   ERRORINFO *errorInfo,
                                                                   long *returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &BGV2ActiveXTrialLib_IID__BeauGaugeCtrlTrial,
	                              0x4, CAVT_LONG, returnValue, 0, NULL);

	return __result;
}

HRESULT CVIFUNC BGV2ActiveXTrialLib__BeauGaugeCtrlTrialSetValue (CAObjHandle objectHandle,
                                                                 ERRORINFO *errorInfo,
                                                                 const char *sName,
                                                                 double fValue,
                                                                 long *returnValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING, CAVT_DOUBLE};

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &BGV2ActiveXTrialLib_IID__BeauGaugeCtrlTrial,
	                              0x5, CAVT_LONG, returnValue, 2, __paramTypes,
	                              sName, fValue);

	return __result;
}

HRESULT CVIFUNC BGV2ActiveXTrialLib__BeauGaugeCtrlTrialAddPlotPoint (CAObjHandle objectHandle,
                                                                     ERRORINFO *errorInfo,
                                                                     const char *sName,
                                                                     double x,
                                                                     double y,
                                                                     long *returnValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING, CAVT_DOUBLE, CAVT_DOUBLE};

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &BGV2ActiveXTrialLib_IID__BeauGaugeCtrlTrial,
	                              0x6, CAVT_LONG, returnValue, 3, __paramTypes,
	                              sName, x, y);

	return __result;
}

HRESULT CVIFUNC BGV2ActiveXTrialLib__BeauGaugeCtrlTrialClearPlot (CAObjHandle objectHandle,
                                                                  ERRORINFO *errorInfo,
                                                                  long *returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &BGV2ActiveXTrialLib_IID__BeauGaugeCtrlTrial,
	                              0x7, CAVT_LONG, returnValue, 0, NULL);

	return __result;
}

HRESULT CVIFUNC BGV2ActiveXTrialLib__BeauGaugeCtrlTrialInitLicense (CAObjHandle objectHandle,
                                                                    ERRORINFO *errorInfo,
                                                                    const char *s1,
                                                                    const char *s2,
                                                                    const char *s3,
                                                                    const char *s4,
                                                                    long *returnValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING, CAVT_CSTRING, CAVT_CSTRING,
	                               CAVT_CSTRING};

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &BGV2ActiveXTrialLib_IID__BeauGaugeCtrlTrial,
	                              0x8, CAVT_LONG, returnValue, 4, __paramTypes,
	                              s1, s2, s3, s4);

	return __result;
}

HRESULT CVIFUNC BGV2ActiveXTrialLib__BeauGaugeCtrlTrialEnableAbout (CAObjHandle objectHandle,
                                                                    ERRORINFO *errorInfo,
                                                                    long bShow,
                                                                    long *returnValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG};

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &BGV2ActiveXTrialLib_IID__BeauGaugeCtrlTrial,
	                              0x9, CAVT_LONG, returnValue, 1, __paramTypes,
	                              bShow);

	return __result;
}

HRESULT CVIFUNC BGV2ActiveXTrialLib__BeauGaugeCtrlTrialSetTransparent (CAObjHandle objectHandle,
                                                                       ERRORINFO *errorInfo,
                                                                       long bTransparent,
                                                                       long *returnValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG};

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &BGV2ActiveXTrialLib_IID__BeauGaugeCtrlTrial,
	                              0xA, CAVT_LONG, returnValue, 1, __paramTypes,
	                              bTransparent);

	return __result;
}

HRESULT CVIFUNC BGV2ActiveXTrialLib__BeauGaugeCtrlTrialSetDateTime (CAObjHandle objectHandle,
                                                                    ERRORINFO *errorInfo,
                                                                    const char *sName,
                                                                    long nYear,
                                                                    long nMonth,
                                                                    long nDay,
                                                                    long nHour,
                                                                    long nMinute,
                                                                    long nSecond,
                                                                    long *returnValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING, CAVT_LONG, CAVT_LONG,
	                               CAVT_LONG, CAVT_LONG, CAVT_LONG, CAVT_LONG};

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &BGV2ActiveXTrialLib_IID__BeauGaugeCtrlTrial,
	                              0xB, CAVT_LONG, returnValue, 7, __paramTypes,
	                              sName, nYear, nMonth, nDay, nHour, nMinute,
	                              nSecond);

	return __result;
}

HRESULT CVIFUNC BGV2ActiveXTrialLib__BeauGaugeCtrlTrialSetRange (CAObjHandle objectHandle,
                                                                 ERRORINFO *errorInfo,
                                                                 const char *sName,
                                                                 double fStart,
                                                                 double fSpan,
                                                                 long nMajorCount,
                                                                 long *returnValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING, CAVT_DOUBLE, CAVT_DOUBLE,
	                               CAVT_LONG};

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &BGV2ActiveXTrialLib_IID__BeauGaugeCtrlTrial,
	                              0xC, CAVT_LONG, returnValue, 4, __paramTypes,
	                              sName, fStart, fSpan, nMajorCount);

	return __result;
}

HRESULT CVIFUNC BGV2ActiveXTrialLib__BeauGaugeCtrlTrialSetBackgroundImage (CAObjHandle objectHandle,
                                                                           ERRORINFO *errorInfo,
                                                                           const char *sPath,
                                                                           long nType,
                                                                           long *returnValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING, CAVT_LONG};

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &BGV2ActiveXTrialLib_IID__BeauGaugeCtrlTrial,
	                              0xD, CAVT_LONG, returnValue, 2, __paramTypes,
	                              sPath, nType);

	return __result;
}

HRESULT CVIFUNC BGV2ActiveXTrialLib__BeauGaugeCtrlTrialSetFillColor (CAObjHandle objectHandle,
                                                                     ERRORINFO *errorInfo,
                                                                     const char *sName,
                                                                     long nA1,
                                                                     long nR1,
                                                                     long nG1,
                                                                     long nB1,
                                                                     long nA2,
                                                                     long nR2,
                                                                     long nG2,
                                                                     long nB2,
                                                                     long *returnValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING, CAVT_LONG, CAVT_LONG,
	                               CAVT_LONG, CAVT_LONG, CAVT_LONG, CAVT_LONG,
	                               CAVT_LONG, CAVT_LONG};

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &BGV2ActiveXTrialLib_IID__BeauGaugeCtrlTrial,
	                              0xE, CAVT_LONG, returnValue, 9, __paramTypes,
	                              sName, nA1, nR1, nG1, nB1, nA2, nR2, nG2,
	                              nB2);

	return __result;
}

HRESULT CVIFUNC BGV2ActiveXTrialLib__BeauGaugeCtrlTrialSetLabel (CAObjHandle objectHandle,
                                                                 ERRORINFO *errorInfo,
                                                                 const char *sName,
                                                                 const char *sLabel,
                                                                 long *returnValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING, CAVT_CSTRING};

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &BGV2ActiveXTrialLib_IID__BeauGaugeCtrlTrial,
	                              0x12, CAVT_LONG, returnValue, 2,
	                              __paramTypes, sName, sLabel);

	return __result;
}

HRESULT CVIFUNC BGV2ActiveXTrialLib__BeauGaugeCtrlTrialModifyPlotPoint (CAObjHandle objectHandle,
                                                                        ERRORINFO *errorInfo,
                                                                        const char *sName,
                                                                        double x,
                                                                        double y,
                                                                        long *returnValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING, CAVT_DOUBLE, CAVT_DOUBLE};

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &BGV2ActiveXTrialLib_IID__BeauGaugeCtrlTrial,
	                              0x15, CAVT_LONG, returnValue, 3,
	                              __paramTypes, sName, x, y);

	return __result;
}

HRESULT CVIFUNC BGV2ActiveXTrialLib__BeauGaugeCtrlTrialDeletePlotPoint (CAObjHandle objectHandle,
                                                                        ERRORINFO *errorInfo,
                                                                        const char *sName,
                                                                        double x,
                                                                        long *returnValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING, CAVT_DOUBLE};

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &BGV2ActiveXTrialLib_IID__BeauGaugeCtrlTrial,
	                              0x16, CAVT_LONG, returnValue, 2,
	                              __paramTypes, sName, x);

	return __result;
}

HRESULT CVIFUNC BGV2ActiveXTrialLib__BeauGaugeCtrlTrialGetGaugeVersion (CAObjHandle objectHandle,
                                                                        ERRORINFO *errorInfo,
                                                                        long *returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &BGV2ActiveXTrialLib_IID__BeauGaugeCtrlTrial,
	                              0x3, DISPATCH_PROPERTYGET, CAVT_LONG,
	                              returnValue, 0, NULL);

	return __result;
}

HRESULT CVIFUNC BGV2ActiveXTrialLib__BeauGaugeCtrlTrialSetGaugeVersion (CAObjHandle objectHandle,
                                                                        ERRORINFO *errorInfo,
                                                                        long newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &BGV2ActiveXTrialLib_IID__BeauGaugeCtrlTrial,
	                              0x3, DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL,
	                              1, __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC BGV2ActiveXTrialLib__BeauGaugeCtrlTrialSetByRefGaugeVersion (CAObjHandle objectHandle,
                                                                             ERRORINFO *errorInfo,
                                                                             long *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &BGV2ActiveXTrialLib_IID__BeauGaugeCtrlTrial,
	                              0x3, DISPATCH_PROPERTYPUTREF, CAVT_EMPTY,
	                              NULL, 1, __paramTypes, newValue);

	return __result;
}

static void CVIFUNC _BeauGaugeCtrlTrialEventsRegOnValueChanged_EventVTableFunc (void *thisPtr,
                                                                                BSTR sName,
                                                                                double fValue)
{
	HRESULT __result = S_OK;
	void * __callbackData;
	CAObjHandle __serverObjHandle;
	_BeauGaugeCtrlTrialEventsRegOnValueChanged_CallbackType __callbackFunction;
	char * sName__CType = 0;
	
	

	__caErrChk (CA_GetEventCallback (thisPtr, 0, &__callbackFunction,
	                                 &__callbackData, &__serverObjHandle));

	if (__callbackFunction != NULL)
		{
		__caErrChk (CA_BSTRGetCString (sName, &sName__CType));
	
		__result = __callbackFunction (__serverObjHandle, __callbackData, sName__CType,
		                               fValue);
	
		__caErrChk (__result);
		
		}
Error:
	CA_FreeMemory (sName__CType);

	return;
}

static void CVIFUNC _BeauGaugeCtrlTrialEventsRegOnRightClicked_EventVTableFunc (void *thisPtr,
                                                                                long nX,
                                                                                long nY)
{
	HRESULT __result = S_OK;
	void * __callbackData;
	CAObjHandle __serverObjHandle;
	_BeauGaugeCtrlTrialEventsRegOnRightClicked_CallbackType __callbackFunction;
	
	

	__caErrChk (CA_GetEventCallback (thisPtr, 1, &__callbackFunction,
	                                 &__callbackData, &__serverObjHandle));

	if (__callbackFunction != NULL)
		{
	
		__result = __callbackFunction (__serverObjHandle, __callbackData, nX, nY);
	
		__caErrChk (__result);
		
		}
Error:

	return;
}

HRESULT CVIFUNC BGV2ActiveXTrialLib__BeauGaugeCtrlTrialEventsRegOnValueChanged (CAObjHandle serverObject,
                                                                                _BeauGaugeCtrlTrialEventsRegOnValueChanged_CallbackType callbackFunction,
                                                                                void *callbackData,
                                                                                int enableCallbacks,
                                                                                int *callbackId)
{
	HRESULT __result = S_OK;

	__result = CA_RegisterEventCallback (serverObject,
	                                     &__BeauGaugeCtrlTrialEvents_CAEventClassDefn,
	                                     0, callbackFunction, callbackData,
	                                     enableCallbacks, callbackId);

	return __result;
}

HRESULT CVIFUNC BGV2ActiveXTrialLib__BeauGaugeCtrlTrialEventsRegOnRightClicked (CAObjHandle serverObject,
                                                                                _BeauGaugeCtrlTrialEventsRegOnRightClicked_CallbackType callbackFunction,
                                                                                void *callbackData,
                                                                                int enableCallbacks,
                                                                                int *callbackId)
{
	HRESULT __result = S_OK;

	__result = CA_RegisterEventCallback (serverObject,
	                                     &__BeauGaugeCtrlTrialEvents_CAEventClassDefn,
	                                     1, callbackFunction, callbackData,
	                                     enableCallbacks, callbackId);

	return __result;
}
